#include "libdef.inc"
#ifdef ASM86_CODE
# include <cv/asm86.h>
#endif
#include <cv/string2.h>

/* "Check for stack overflow" off for BC++ 3.1 */
#pragma option -N-

/*----------------------------------------------------------------------*/
/*   襣 ᮢ饣 ⪠ 			*/
size_t SMALL_ memmatch(CVP p1, CVP p2, size_t sz){
#ifdef STD_CODE

	size_t cnt = sz;
	while(cnt && *(*(const byte**)&p1)++ == *(*(const byte**)&p2)++) cnt--;
	return sz - cnt;

#elif !defined(ASM86_CODE)

	/* ⤥쭠 ஢ઠ ࢮ , ᫨  ⭠	*/
	if(odd(sz) && *(*(const byte**)&p1)++ != *(*(const byte**)&p2)++)
		return 0;

	/* ᫮ ࠢ  ஢				*/
	for(size_t cnt = sz >> 1; cnt; cnt--){
		if(*(*(const word**)&p1)++ != *(*(const word**)&p2)++){
			/* ⫨稥  ᫥ ᫮ - ஢ 	*/
			return sz - cnt - cnt +
				((((const byte*)p1)[-2] ==
					((const byte*)p2)[-2]) ? 1 : 0);
	}	}

	return sz;
#else
	_DX = _DS;
	I LES_ di, DPTR_(p2);
	I LDS_ si, DPTR_(p1);
#  ifndef FARDATA
	_ES = _DX;
#  endif

	I cld; _CX = _AX = sz; _CX >>= 1;

	/* ⤥쭠 ஢ઠ ࢮ , ᫨  ⭠	*/
	if(isFLAG(Carry)){
		I cmpsb; if(!isFLAG(Equal)) { _CLR(_AX); goto DONE; }
	}

	/* ᫮ ࠢ  ஢				*/
	I jcxz DONE; I repe cmpsw;
	if(!isFLAG(Equal)){
		/* ⫨稥  ᫥ ᫮ - ஢ 		*/
		_AX -= _CX; _AX -= _CX;  /* ᫨ ⢮ ᮢ */
		I mov cl, si[-2]; _AX--; /*     ஢  	*/
		I cmp ES_ di[-2], cl;	 /*   ᮢ襬 ᫮		*/
		if(!isFLAG(Equal)) _AX--;/*   ᮢ	*/
	}
DONE:
#  ifdef FARDATA
	_DS = _DX;
#  endif
	return _AX;
#endif
}
